//=====================================================================
// LinkServer.h
// © Michael Pieper 14. Feb. 1999
//=====================================================================
//
//  This headerfile defines the class "LinkServer", which is used to
//  manage the LINK-Connection from the PSION
//
//=====================================================================

#ifndef LINKSERVER_H
#define LINKSERVER_H

#include "debugMsg.h"
#include "LinkServerAddOn.h"
#include <SupportKit.h>			// needed for uint16 definition

//=====================================================================
//  LinkServer class
class LinkServer
{
public:
	//constructor and destructor
					LinkServer( CONFIG_VAR *config );
	
	//operations
	void			RunServer( void );	// waits for a Message and manages this message

protected:
	// global variables need to communicate
	uint16			cid;			// Channelid to talk to the NCP
	port_id			pid_o, pid_i;	// Portids for the message handling
	DebugMsg		*dprint;		// Class for Debug-Messagees
};

//****************************************

#endif
